Bug 1768774 - Review Request: golang-github-osbuild-composer - An image building service based on osbuild
Summary: Review Request: golang-github-osbuild-composer - An image building service ba...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Jakub Čajka
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2019-11-05 08:59 UTC by obudai
Modified: 2020-06-14 08:00 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-06-14 08:00:09 UTC
Type: ---
jcajka: fedora-review+


Attachments (Terms of Use)

Description obudai 2019-11-05 08:59:25 UTC
Spec URL: https://github.com/osbuild/osbuild-composer/blob/24e3e5f8bef01a9089b30d171f0471e3d15b6a34/golang-github-osbuild-composer.spec
SRPM URL: https://budai.cz/golang-github-osbuild-composer-1-1.fc31.src.rpm
Description: An image building service based on osbuild. It is inspired by lorax-composer and exposes the same API. As such, it is a drop-in replacement.
Fedora Account System Username: obudai
Koji build: https://koji.fedoraproject.org/koji/taskinfo?taskID=38773902

This is my first package. I'm member of osbuild team maintaining osbuild-composer project.

Comment 1 Jakub Čajka 2019-11-11 13:48:36 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

Issues:
=======
- systemd_post is invoked in %post, systemd_preun in %preun, and
  systemd_postun in %postun for Systemd service files.
  Note: Systemd service file(s) in golang-github-osbuild-composer
  See: https://docs.fedoraproject.org/en-US/packaging-guidelines/Scriptlets/#_scriptlets
  and https://docs.fedoraproject.org/en-US/packaging-guidelines/Systemd/#_packaging
- directory "osbuild-composer" is not owned
  See: https://docs.fedoraproject.org/en-US/packaging-guidelines/UnownedDirectories/#_unversioned
  but the binaries should live in bindir or in libexecdir if they are not for human users
  See: https://docs.fedoraproject.org/en-US/packaging-guidelines/#_effect_of_the_usrmove_fedora_feature
  and https://docs.fedoraproject.org/en-US/packaging-guidelines/#_libexecdir
- LICENSE template is not filled in.
- rpmlint issues

===== MUST items =====

Generic:
[!]: Package complies to the Packaging Guidelines
[!]: Package must own all directories that it creates.
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[!]: Sources can be downloaded from URI in Source: tag
     Note: Could not download Source0: https://github.com/osbuild/osbuild-
     composer/archive/v1/osbuild-composer-1.tar.gz
     See: https://docs.fedoraproject.org/en-US/packaging-
     guidelines/SourceURL/
[!]: SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments
[?]: Package functions as described.
[?]: Latest version is packaged.
[x]: Final provides and requires are sane (see attachments).
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: golang-github-osbuild-composer-1-1.fc32.x86_64.rpm
          golang-github-osbuild-composer-debuginfo-1-1.fc32.x86_64.rpm
          golang-github-osbuild-composer-debugsource-1-1.fc32.x86_64.rpm
          golang-github-osbuild-composer-1-1.fc32.src.rpm
golang-github-osbuild-composer.x86_64: W: summary-ended-with-dot C An image building service based on osbuild.
golang-github-osbuild-composer.x86_64: W: spelling-error %description -l en_US lorax -> borax
golang-github-osbuild-composer.x86_64: W: incoherent-version-in-changelog 0-1 ['1-1.fc32', '1-1']
golang-github-osbuild-composer.x86_64: E: non-executable-script /usr/lib/osbuild-composer/dnf-json 644 /usr/bin/python3 
golang-github-osbuild-composer.src: W: summary-ended-with-dot C An image building service based on osbuild.
golang-github-osbuild-composer.src: W: spelling-error %description -l en_US lorax -> borax
golang-github-osbuild-composer.src:46: E: hardcoded-library-path in %{_prefix}/lib/osbuild-composer
golang-github-osbuild-composer.src:47: E: hardcoded-library-path in %{_prefix}/lib/osbuild-composer/
golang-github-osbuild-composer.src:48: E: hardcoded-library-path in %{_prefix}/lib/osbuild-composer/
golang-github-osbuild-composer.src:74: E: hardcoded-library-path in %{_prefix}/lib/osbuild-composer/*
golang-github-osbuild-composer.src: E: specfile-error warning: %gobuildroot is obsolete, use %goprep in %prep instead!
4 packages and 0 specfiles checked; 6 errors, 5 warnings.




Rpmlint (debuginfo)
-------------------
Checking: golang-github-osbuild-composer-debuginfo-1-1.fc32.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
golang-github-osbuild-composer-debuginfo.x86_64: W: invalid-url URL: https://github.com/osbuild/osbuild-composer <urlopen error [Errno -2] Name or service not known>
golang-github-osbuild-composer.x86_64: W: summary-ended-with-dot C An image building service based on osbuild.
golang-github-osbuild-composer.x86_64: W: spelling-error %description -l en_US lorax -> borax
golang-github-osbuild-composer.x86_64: W: incoherent-version-in-changelog 0-1 ['1-1.fc32', '1-1']
golang-github-osbuild-composer.x86_64: W: invalid-url URL: https://github.com/osbuild/osbuild-composer <urlopen error [Errno -2] Name or service not known>
golang-github-osbuild-composer.x86_64: E: non-executable-script /usr/lib/osbuild-composer/dnf-json 644 /usr/bin/python3 
golang-github-osbuild-composer-debugsource.x86_64: W: invalid-url URL: https://github.com/osbuild/osbuild-composer <urlopen error [Errno -2] Name or service not known>
3 packages and 0 specfiles checked; 1 errors, 6 warnings.



Requires
--------
golang-github-osbuild-composer (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libcrypt.so.2()(64bit)
    libcrypt.so.2(XCRYPT_2.0)(64bit)
    libpthread.so.0()(64bit)
    osbuild
    rtld(GNU_HASH)
    systemd

golang-github-osbuild-composer-debuginfo (rpmlib, GLIBC filtered):

golang-github-osbuild-composer-debugsource (rpmlib, GLIBC filtered):



Provides
--------
golang-github-osbuild-composer:
    golang-github-osbuild-composer
    golang-github-osbuild-composer(x86-64)

golang-github-osbuild-composer-debuginfo:
    debuginfo(build-id)
    golang-github-osbuild-composer-debuginfo
    golang-github-osbuild-composer-debuginfo(x86-64)

golang-github-osbuild-composer-debugsource:
    golang-github-osbuild-composer-debugsource
    golang-github-osbuild-composer-debugsource(x86-64)

Comment 2 Tom Gundersen 2019-11-11 21:56:22 UTC
Thanks for the quick review Jakub!

I updated the specfile and made a new upstream release that should address all your comments.

Spec URL: https://github.com/osbuild/osbuild-composer/blob/1055d1167dc1399a2b8be0caf5ea415c9aa2b155/golang-github-osbuild-composer.spec
SRPM URL: https://tomegun.fedorapeople.org/golang-github-osbuild-composer-2-1.fc32.src.rpm
Koji build: https://koji.fedoraproject.org/koji/taskinfo?taskID=38926866

Comment 3 Jakub Čajka 2019-11-13 10:14:17 UTC
LGTM, only issue is, based on the https://docs.fedoraproject.org/en-US/packaging-guidelines/UnownedDirectories/#_unversioned , in %files section "%{_libexecdir}/osbuild-composer"
 is just enough to include all the files, listing them leads to "Package does not contain duplicates in %files". Thanks for quick iteration. New review-report follows.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


Issues:
=======
- Package does not contain duplicates in %files.
  Note: warning: File listed twice: /usr/lib/.build-
  id/97/86a9f1f2fb30324b33c3e5d8e44c96081c4b34
  See: https://docs.fedoraproject.org/en-US/packaging-
  guidelines/#_duplicate_files


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: License file installed when any subpackage combination is installed.
[x]: Package does not own files or directories owned by other packages.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: systemd_post is invoked in %post, systemd_preun in %preun, and
     systemd_postun in %postun for Systemd service files.
     Note: Systemd service file(s) in golang-github-osbuild-composer
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: golang-github-osbuild-composer-2-1.fc32.x86_64.rpm
          golang-github-osbuild-composer-debuginfo-2-1.fc32.x86_64.rpm
          golang-github-osbuild-composer-debugsource-2-1.fc32.x86_64.rpm
          golang-github-osbuild-composer-2-1.fc32.src.rpm
golang-github-osbuild-composer.x86_64: W: summary-ended-with-dot C An image building service based on osbuild.
golang-github-osbuild-composer.x86_64: W: spelling-error %description -l en_US lorax -> borax
golang-github-osbuild-composer.src: W: summary-ended-with-dot C An image building service based on osbuild.
golang-github-osbuild-composer.src: W: spelling-error %description -l en_US lorax -> borax
4 packages and 0 specfiles checked; 0 errors, 4 warnings.




Rpmlint (debuginfo)
-------------------
Checking: golang-github-osbuild-composer-debuginfo-2-1.fc32.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
golang-github-osbuild-composer-debugsource.x86_64: W: invalid-url URL: https://github.com/osbuild/osbuild-composer <urlopen error [Errno -2] Name or service not known>
golang-github-osbuild-composer-debuginfo.x86_64: W: invalid-url URL: https://github.com/osbuild/osbuild-composer <urlopen error [Errno -2] Name or service not known>
golang-github-osbuild-composer.x86_64: W: summary-ended-with-dot C An image building service based on osbuild.
golang-github-osbuild-composer.x86_64: W: spelling-error %description -l en_US lorax -> borax
golang-github-osbuild-composer.x86_64: W: invalid-url URL: https://github.com/osbuild/osbuild-composer <urlopen error [Errno -2] Name or service not known>
3 packages and 0 specfiles checked; 0 errors, 5 warnings.



Source checksums
----------------
https://github.com/osbuild/osbuild-composer/archive/v2/osbuild-composer-2.tar.gz :
  CHECKSUM(SHA256) this package     : 5f514bd587cd028dab0950caa01f9d2b753756bf237bdabd072203ecefb3575e
  CHECKSUM(SHA256) upstream package : 5f514bd587cd028dab0950caa01f9d2b753756bf237bdabd072203ecefb3575e


Requires
--------
golang-github-osbuild-composer (rpmlib, GLIBC filtered):
    /bin/sh
    /usr/bin/python3
    libc.so.6()(64bit)
    libcrypt.so.2()(64bit)
    libcrypt.so.2(XCRYPT_2.0)(64bit)
    libpthread.so.0()(64bit)
    osbuild
    rtld(GNU_HASH)
    systemd

golang-github-osbuild-composer-debuginfo (rpmlib, GLIBC filtered):

golang-github-osbuild-composer-debugsource (rpmlib, GLIBC filtered):



Provides
--------
golang-github-osbuild-composer:
    golang-github-osbuild-composer
    golang-github-osbuild-composer(x86-64)

golang-github-osbuild-composer-debuginfo:
    debuginfo(build-id)
    golang-github-osbuild-composer-debuginfo
    golang-github-osbuild-composer-debuginfo(x86-64)

golang-github-osbuild-composer-debugsource:
    golang-github-osbuild-composer-debugsource
    golang-github-osbuild-composer-debugsource(x86-64)



Generated by fedora-review 0.7.3 (44b83c7) last change: 2019-09-18
Command line :/usr/bin/fedora-review -n golang-github-osbuild-composer
Buildroot used: fedora-rawhide-{{ target_arch }}
Active plugins: Shell-api, Generic
Disabled plugins: Python, SugarActivity, Java, Haskell, R, Perl, fonts, C/C++, Ocaml, PHP
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 5 Jakub Čajka 2019-11-14 13:50:19 UTC
Looks good to me, the last issue as mentioned is fixed. Thank you for submitting a package. Approving.

If you would have any questions or need any help. Feel free to reach out to me.

PS:You can "reset" the release number for the actual Fedora build.

Comment 6 Gwyn Ciesla 2019-11-14 17:16:25 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/golang-github-osbuild-composer

Comment 7 obudai 2019-11-15 06:59:41 UTC
Thanks much Jakub and Gwyn for quick responses!

Comment 8 Mattia Verga 2020-06-14 08:00:09 UTC
This package was approved and imported in repositories, but this review ticket was never closed.
I'm closing it now.


Note You need to log in before you can comment on or make changes to this bug.